#include "main.h"


//0 if the game isn't running
int running;
int frames;
int seconds;
int fps;
int showfps;

/*
 * Small routine to generate random numbers
 * between 0.0f and 1.0f
 */
float rnd() {
    return (float)(rand()%10000)/10000;
}

/*
 * Initialise graphics, input and sound
 */
void init() {
    //Randomize the random number generator    
    srand((unsigned int)time(NULL));
    //initialise SDL & the video subsystem
    SDL_Init(SDL_INIT_VIDEO|SDL_INIT_TIMER|SDL_INIT_AUDIO);  
    //other init
    gfxinit();
    soundinit();
    inputinit();
	running = 1;
	seconds = 1;
	frames = 0;
	fps = -1;
	showfps = 0;
}
/*
 * Perform a single 'logic frame'
 */
void dologic() {
	//Polls for events (currently only SDL_QUIT does anything)
    pollevents();
}
/*
 * Uninitialise sound and SDL
 */
void deinit() {
	sounddeinit();
    SDL_Quit();
}

void gameloop()
{
	
}


int escapekeyrepeat = FALSE;
/*
 * Main method, where is all begins
 *
 * int argc       number of arguments  (not used)
 * char *argv[]   pointer to arguments (not used)
 */
int main(int argc, char *argv[])
{

    //Initialise the game
    init();   
    
    //Loop for game then menu then game then ....
    while (running)
    {
         //Gets the SDL ticks (number of milliseconds since SDL started)
        int phystime=SDL_GetTicks();

        //Game loop
        while (running)
        {
	        char buffer[256];
	        frames++;
	        if(SDL_GetTicks() > seconds*1000)
	        {
		        seconds++;
		        fps = frames;
		        frames = 0;
	        }
	        
            //'Catch up' with logic frames
            while (phystime<SDL_GetTicks())
            {
                dologic();
                phystime+=T_PHYS;
            }

            if (key[SDLK_ESCAPE])
	        	running = 0;

            //Clear the screen ready for drawing
            cls();
            //Set the colour to draw everything in
            setcol(1.0f,1.0f,1.0f);
			// DO MAIN DRAWING HERE
			if(fps != -1)
			{	
				if(showfps)
				{
					sprintf(buffer, "%d fps", fps);
					drawshadowedstring(buffer,0,0,1,1,0.5);
				}
			}
            //Flip the screen
            gfxflip();
        }    
    }
    
    deinit();
    return(0);
}
