#ifndef _MAIN_H
#define _MAIN_H

#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <SDL/SDL.h>
#include <SDL/SDL_Image.h>
#include <GL/gl.h>

//general
extern int running;
#define PI 3.1416
#define RAD(x) (x*PI/180.0f)
#define T_PHYS (1000/50)
#define TRUE (1)
#define FALSE (0)
typedef struct {
    float x;
    float y;
} xy;
float rnd();
extern char *openfilename;
extern int showfps;

//graphics
extern int XRES;
extern int YRES;
extern int PIXEL_SCALE;
extern int fullscreen;

#define SPRITE_SIZE 16 // 16x16
#define SPRITE_SHEET_SIZE 8 // 8x8
#define SPRITE_RENDER_SIZE (SPRITE_SIZE*PIXEL_SCALE)
#define FONT_SIZE (8*PIXEL_SCALE)

typedef enum
{
	SPRITE_MAX,
} Sprite;

void cls();
void gfxinit();  //initialise gl graphics
void gfxflip();
void drawbox(float x1,float y1,float x2,float y2);
void loadimage(char *filename, GLuint *texture);
void drawstring(char *string,float x,float y);
void drawshadowedstring(char *string, float x, float y, float r, float g, float b);
void setcol(float r,float g,float b);
void setcol4(float r, float g, float b, float a);
void initspritedraw();
void drawscaledsprite(Sprite sprite, float x, float y, int scale);
void drawsprite(Sprite sprite, float x, float y);
void deinitspritedraw();
xy angtoxy(float angle,float distance);
void formattime(char* buffer, int milliseconds);
void setresolution(int x, int y, int pixelsize);
void togglefullscreen();

//input
extern Uint8 * key;
extern Uint8 keypressed[SDLK_LAST];
void pollevents();
void inputinit();

//sound
extern int musicplaying;
extern int playsounds;
typedef enum
{
	SOUND_MAX,
} Sound;
void soundinit();
void sounddeinit();
void playmusic();
void stopmusic();
void playsound(Sound sound);
void togglesounds();
void togglemusic();
void mute(int on);

#endif
